(function ($) {
	$(document).ready(function () {



		function addExportCSVButton() {
			var buttons = '<div class="csp-export-buttons"><button type="button" class="button button-primary tips csomagpont_api_send_btn" name="csomagpont_api_send">Feladás Csomagponttal</button>';
			buttons += '<button type="button" class="button button-primary tips csp_api_label_btn" name="csp_api_label">Csomagcímke</button>';
			buttons += '<button type="button" class="button button-primary tips csp_api_mpl_sending_btn" name="csp_api_mpl_sending">Feladójegyzék</button>';
			buttons += '</div>';

			$(buttons).insertAfter('.tablenav-pages');
		}

		function getCheckedOrders() {
			var orderIDs = [];
			$('#the-list input[id^=cb-select-]:checkbox:checked').each(function () {
				if ($(this).parent().parent().children('.group_code').children('select').val()) {
					orderIDs.push($(this).parent().parent().children('.group_code').children('select').val());
				}
			})

			return orderIDs;
		}

		function getCheckedSentOrders() {
			var orderIDs = [];
			$('#the-list input[id^=cb-select-]:checkbox:checked').each(function () {
				if ($(this).parent().parent().children('.group_code').children('.csomagpont-cell').data('groupid')) {
					orderIDs.push($(this).parent().parent().children('.group_code').children('.csomagpont-cell').data('groupid'));
				}
			})

			return orderIDs;
		}

		function getCheckedMplSentOrders() {
			var orderIDs = [];
			$('#the-list input[id^=cb-select-]:checkbox:checked').each(function () {
				if ($(this).parent().parent().children('.group_code').children('.csomagpont-cell').data('groupid') &&
					$(this).parent().parent().children('.group_code').children('.csp-mpl-sent').length) {
					orderIDs.push($(this).parent().parent().children('.group_code').children('.csomagpont-cell').data('groupid'));
				}
			})

			return orderIDs;
		}

		function getPackageForChecked() {
			var packages = [];
			$('#the-list input[id^=cb-select-]:checkbox:checked').each(function () {
				if ($(this).parent().parent().children('.group_code').children('.csomagpont-cell').data('dsmid')) {
					const packageId = $(this).parent().parent().children('.group_code').children('.csomagpont-cell').data('groupid');
					const delivery = $(this).parent().parent().children('.group_code').children('.csomagpont-cell').data('dsmid');
					packages.push({
						packageId,
						delivery
					})
				}
			})

			return packages;
		}

		function csomagpontSend(url) {
			var orderIDs = getCheckedOrders();

			if (orderIDs.length > 0) {
				$('button[name=csomagpont_api_send]').text('Rendelések küldése folyamatban...')
				orderIDs = orderIDs.join();
				url += orderIDs;
				window.location.href = url;

			} else {
				stopLoading();
				alert('Kérjük válasszon legalább egy rendelést, amely még nincs feladva és érvényes szállítási móddal rendelkezik!');
			}
		}

		// Ajax fájlok letöltéséhez
		function cspOpenAjaxLink(url) {
			const a = document.createElement('a');
			a.style = 'display: none';
			a.target = '_blank';
			document.body.appendChild(a);
			a.href = url;
			a.click();
		};

		function startLoading() {
			$('.csp-loader').show();
		}

		function stopLoading() {
			$('.csp-loader').hide();
		}

		stopLoading();

		$(document).on('click', '.csomagpont_api_send_btn', function (e) {
			startLoading();
			var currentURL = document.URL;
			var apiURL = currentURL.split('edit.php')[0] + 'edit.php?post_type=shop_order&csomagpont_api_send=';

			csomagpontSend(apiURL);
		});

		$(document).on('click', '.csp_api_label_btn', function (e) {
			startLoading();
			var packages = getPackageForChecked();
			if (packages.length < 1) {
				stopLoading();
				alert('Egy kiválasztott rendelés sincs elküldve');
				return;
			}
			$.ajax({
				type: "POST",
				url: ajaxurl,
				data: {
					action: 'csp_api_label',
					packages: packages
				},
				success: function (url) {
					stopLoading();
					cspOpenAjaxLink(url);
				},
				error: function (error) {
					stopLoading();
					alert(error);
				},
			})
		});

		$(document).on('click', '.csp_api_mpl_sending_btn', function (e) {
			startLoading();
			var groupIDs = getCheckedMplSentOrders();
			if (groupIDs.length < 1) {
				alert('Egy kiválasztott rendelés sincs MPL futárszolgálattal elküldve');
				return;
			}
			groupIDs = groupIDs.join();
			$.ajax({
				type: "POST",
				url: ajaxurl,
				data: {
					action: 'csp_api_mpl_sending',
					group_ids: groupIDs
				},
				success: function (url) {
					stopLoading();
					cspOpenAjaxLink(url);
				},
				error: function (error) {
					stopLoading();
					alert(error);
				},
			})
		});





		addExportCSVButton();
	});
})(jQuery);